moDrawPage1 = {};

function moDrawPage1:setOpenPage(self)
	local tablePos, moFillTypesStationsSort = sortFillTypes(self, farmSilo);	
	moSetGetStationes:setStationsMaxProSwitch(self);
	moSetGetStationes:setFirstEndStations(self);
	moSetGetFillTypes:setFruitsMaxProSwitch(self);
	moSetGetFillTypes:setFruitsFirstEnd(self);
	local farmSilo = moGeneralSettings.multiFarmSilo;
	local posX = moSetGetGui.page[1].posX+0.001;
	local posY = moSetGetGui.page[1].posY;
	local size = moSetGetGui.page[1].size;
	local widthSettings = moSetGetGui.buttonGfxWidth1*moSetGetGui.zoomOutInTemp*4;
	local heightSettings = moSetGetGui.buttonGfxHeight1*moSetGetGui.zoomOutInTemp*4;	
	local height = moSetGetGui.buttonGfxHeight1*(size*1000);
	local heightDefault = moSetGetGui.buttonGfxHeight1*(size*1000);
	local distanceDif = 0.01; --station <----> station
	--local fruitLength = size/3*(moGeneralSettings.lengthFruitName+moSetGetGui.screenAspectRatio)*1.03; --size/3*(moGeneralSettings.lengthFruitName+4+moSetGetGui.screenAspectRatio)*1.03;
	--local amountLength = size/3*(moGeneralSettings.lengthAmount+moSetGetGui.screenAspectRatio)*1.03;	
	local fruitLength = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(moGeneralSettings.lengthFruitName+moSetGetGui.screenAspectRatio)+widthSettings; --moSetGetGui.buttonGfxWidth1*(size*1000/2)*(moGeneralSettings.lengthFruitName);
	local amountLength = moSetGetGui.buttonGfxWidth1*(size*1000/2.5)*(moGeneralSettings.lengthAmount+moSetGetGui.screenAspectRatio);
	local width = fruitLength+amountLength+0.02; --distanceDif; 0.02 fruits <----> amount
	local widthStations = 0;
	--local widthGround = moSetGetGui.buttonGfxWidth1*(size*1000/2)*(moGeneralSettings.lengthFruitName+moGeneralSettings.lengthAmount+distanceDif);
	local currentPosY = posY;	
	function nextLine(setHeight, posYnew, setLine, posYline, widthLine, heightLine, onlyLine)
		if setLine then
			moSetGetGui:setOverlay(self, moSetGetGui["designLine"], posX-0.001, currentPosY-(posYline), widthLine, heightLine);
			moSetGetGui["designLine"]:render();
			if onlyLine then return;end;
		end;		
		if setHeight then height = height+(heightDefault)+posYnew;end; --height+size+posNew;
		currentPosY = currentPosY-(heightDefault)-posYnew; --posY-(size+posYnew);		
	end;	
	moSetGetGui["designGround"]:render();
	--settings
	moSetGetGui["slotPos"]:setPosition(posX, posY);
	moSetGetGui["slotPos"]:render();
	moSetGetGui["slotTrain"]:setPosition(posX+(widthSettings*1), posY);
	moSetGetGui["slotTrain"]:render();
	if moGeneralSettings.trainStationFound then
		if not moGeneralSettings.isTrainPrice then
			moSetGetGui["slotNotOkay"]:setPosition(posX+(widthSettings*1), posY);
			moSetGetGui["slotNotOkay"]:render();
		end;
	else
		moSetGetGui["slotNotReady"]:setPosition(posX+(widthSettings*1), posY);
		moSetGetGui["slotNotReady"]:render();
	end;
	moSetGetGui["slotNextL"]:setPosition(posX+(widthSettings*2), posY);
	moSetGetGui["slotNextL"]:render();
	moSetGetGui["slotNextR"]:setPosition(posX+(widthSettings*4), posY);
	moSetGetGui["slotNextR"]:render();
	setTextBold(true);	
	setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
	local sizeTemp = 0.011;
	if size < sizeTemp then sizeTemp = size;end;
	renderText(posX+(widthSettings*3.2), posY+0.0035, sizeTemp, tostring(moGeneralSettings.multiFarmSilo));
	setTextColor(unpack(moGuiMiniPdaSlots.bestPriceColor));
	if moGeneralSettings.multiFarm and moGeneralSettings.multiFarmSilo == 0 or not moGeneralSettings.multiFarm then
		renderText(posX+(widthSettings*5.2), posY+0.0035, sizeTemp, tostring(moLanguageXml:getTxt("farmsilo")));
	else
		renderText(posX+(widthSettings*5.2), posY+0.0035, sizeTemp, tostring(moLanguageXml:getTxt("farm")).. ": ");
	end;
	--settings	
	nextLine(true, 0.005, false);
	local day = g_currentMission.environment.currentDay;	
	local day1 = moLanguageXml:getTxt("day".. math.mod(day, 7));
	local playDays = moLanguageXml:getTxt("playdays");
	renderText(posX, currentPosY, size, tostring(playDays).. ": ".. tostring(day).. " ".. tostring(day1));
	--
	function getMapStations()		
		return moSetGetGui.page[1].firstStation, moSetGetGui.page[1].endStation;
	end;
	local tempStationsDisplay = 0;
	local firstStationsDisplay, maxStationsDisplay = getMapStations();
	function getMapFruits()		
		return moSetGetGui.page[1].firstFruit, moSetGetGui.page[1].endFruit;
	end;
	local firstFruitsDisplay, maxFruitsDisplay = getMapFruits();
	local tempFruitsDisplay = 0;
	--set notice Stationes
	local noticeStation = {};
	local number = 1;
	for k,v in pairs(moStationes) do			
		tempStationsDisplay = tempStationsDisplay+1;
		if tonumber(tempStationsDisplay) >= tonumber(firstStationsDisplay) then				
			if tonumber(firstStationsDisplay) > tonumber(maxStationsDisplay) then break;end;
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			firstStationsDisplay = firstStationsDisplay+1;
			noticeStation[number] ={};
			noticeStation[number].station = moStationes[k].station;			
			local length = moStationes[k].stationNameLength;
			if length < moGeneralSettings.lengthStation then
				length = moGeneralSettings.lengthStation;
			end;
			noticeStation[number].width = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(length+moSetGetGui.screenAspectRatio)+distanceDif;
			noticeStation[number].currentPosX = posX+width+widthStations;			
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			if moStationes[k].isTrain then
				moSetGetGui["slotTrain"]:setPosition(noticeStation[number].currentPosX, currentPosY);
				moSetGetGui["slotTrain"]:render();
				noticeStation[number].currentPosX = noticeStation[number].currentPosX+widthSettings;
				if moGeneralSettings.isTrainPrice then setTextColor(unpack(moGuiMiniPdaSlots.bestPriceColor));end;
			end;
			renderText(noticeStation[number].currentPosX, currentPosY, size, tostring(moStationes[k].stationName));
			widthStations = widthStations+noticeStation[number].width;
			number = number+1;
		end;			
	end;	
	--set notice Stationes
	--set Amount Fruits
	function nextFruitsLine(k, emptyFruit)
		nextLine(true, 0.007, true, 0.0035, width+widthStations, 0.001);
		if emptyFruit then 
			setTextColor(unpack(moGuiMiniPdaSlots.activeColor));
			setTextBold(true);
		else
			setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));
			setTextBold(false);
		end;
		if moGeneralSettings.foundGreatDemand > 0 and moFillTypes[k].greatDemandStation ~= nil then setTextColor(unpack(moGuiMiniPdaSlots.demandColor));end;
		if string.find(moFillTypes[k].fruitName, "!") then
			setTextColor(unpack(moGuiMiniPdaSlots.warningColor3));
			renderText(posX+widthSettings, currentPosY, size, "!".. tostring(moFillTypes[k].descName));
		else
			renderText(posX+widthSettings, currentPosY, size, tostring(moFillTypes[k].fruitName));	
		end;
		local iconType = "Equal";
		if moFillTypes[k].stateHourPrice == 1 then iconType = "Up";elseif moFillTypes[k].stateHourPrice == 2 then iconType = "Down";end;
		moSetGetGui["slotPrice".. iconType]:setPosition(posX, currentPosY-0.0015);
		moSetGetGui["slotPrice".. iconType]:render();
		local amountTemp = g_i18n:formatNumber(Utils.getNoNil(moFillTypes[k].siloAmount[farmSilo],0)); --string.format("%1.0f", Utils.getNoNil(moFillTypes[k].siloAmount[farmSilo],0));					
		setTextAlignment(RenderText.ALIGN_RIGHT);
		if emptyFruit then 
			setTextColor(unpack(moGuiMiniPdaSlots.siloColor));
			setTextBold(true);
		else
			setTextColor(unpack(moGuiMiniPdaSlots.inactiveColor));
			setTextBold(false);
		end;
		renderText(posX+width-0.002, currentPosY, size, tostring(amountTemp));		
		--set Stationes
		if table.getn(noticeStation) > 0 then
			--for k1,v1 in pairs(noticeStation) do
			for a=1, table.getn(noticeStation) do
				local station = noticeStation[a].station;				
				if moFillTypes[k].stationPriceMulti[station.. " PriceMulti"] then					
					setTextColor(unpack(moGuiMiniPdaSlots.priceColor));
					local greatDemandMultiplier = 1;
					local foundDemand = false;
					if moStationes[station].greatDemand and string.find(moStationes[station].greatDemandFruit, moFillTypes[k].descName.. " ") then 
						setTextColor(unpack(moGuiMiniPdaSlots.demandColor));
						greatDemandMultiplier = moStationes[station].greatDemandMultiplier
						foundDemand = true;
					end;					
					local price = moFillTypes[k].pricePerLiter*moFillTypes[k].stationPriceMulti[station.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*greatDemandMultiplier*1000;								
					if string.find(moGeneralSettings.foundAnimals, moFillTypes[k].descName.. " ") then									
						price = moFillTypes[k].pricePerLiter/1000*moFillTypes[k].stationPriceMulti[station.. " PriceMulti"]*moGeneralSettings.difficultyMultiplier*greatDemandMultiplier*1000;
					end;																
					local priceTemp = string.format("%.1f", Utils.getNoNil(price,0));
					if not foundDemand and emptyFruit and tonumber(moFillTypes[k].bestPrice) == tonumber(moFillTypes[k].stationPriceMulti[station.. " PriceMulti"]) then								
						setTextColor(unpack(moGuiMiniPdaSlots.bestPriceColor));
					end;
					--if moStationes[k1].close then setTextColor(unpack(moGuiExtras.colors['redDisabled']));pricesTemp = "close";end;	
					--local priceLetterFormel = moStationes[station].firstLetter+moSetGetGui.pdaMenueSize/3*(moStationes[station].stationNameLength/1.65)*1.03
					--local priceLetter = moSetGetGui.buttonGfxWidth1*(size*1000/1.5)*(priceTemp+moSetGetGui.screenAspectRatio);
					setTextAlignment(RenderText.ALIGN_CENTER);
					local priceLetterFormel = noticeStation[a].currentPosX+(noticeStation[a].width/3.5);
					renderText(priceLetterFormel, currentPosY, size, tostring(priceTemp));						
				end;										
			end;
		end;
		setTextAlignment(false);
		--set Stationes
	end;		
	if table.getn(moFillTypesStationsSort) > 0 then		
		for a=1, table.getn(moFillTypesStationsSort) do		
			tempFruitsDisplay = tempFruitsDisplay+1;
			if tonumber(tempFruitsDisplay) >= tonumber(firstFruitsDisplay) then				
				if tonumber(firstFruitsDisplay) > tonumber(maxFruitsDisplay) then break;end;				
				firstFruitsDisplay = firstFruitsDisplay+1;
				if not moSetGetGui.page[1].allFruits and tonumber(a) > tonumber(tablePos) then break;end;
				if tonumber(a) > tonumber(tablePos) then						
					if tonumber(moFillTypes[moFillTypesStationsSort[a]].siloAmount[farmSilo]) <= 1 then 
						nextFruitsLine(moFillTypesStationsSort[a], false);
					else
						nextFruitsLine(moFillTypesStationsSort[a], true);
					end;					
				else						
					if tonumber(moFillTypes[moFillTypesStationsSort[a]].siloAmount[farmSilo]) <= 1 then
						nextFruitsLine(moFillTypesStationsSort[a], false);
					else
						nextFruitsLine(moFillTypesStationsSort[a], true);
					end;							
				end;
			end;
		end;
		nextLine(true, 0, true, 0.0035, width+widthStations, 0.001);
	end;
	--set Amount Fruits	
	moSetGetGui:setOverlay(self, moSetGetGui["designGround"], posX-0.001, currentPosY, width+widthStations, height+heightSettings);
	moMouseClickAreas.dragDropPos["page1"] = {width=width+widthStations, height=height+heightSettings};
	setTextBold(false);
	setTextColor(false);
	setTextAlignment(false);
	--renderText(false);	
end;

function sortFillTypes(self, farmSilo)
	local fillTypesStationsSort = {};
	local tablePos = 0;
	moGeneralSettings.lengthAmount = 7;
	function setNextTable(k, nextTablePos)
		if nextTablePos then tablePos = tablePos+1;end;
		table.insert(fillTypesStationsSort, tablePos, k);
		local checkLengthAmount = string.len(string.format("%.0f", Utils.getNoNil(moFillTypes[k].siloAmount[farmSilo],0)));
		if nextTablePos and checkLengthAmount > moGeneralSettings.lengthAmount then
			moGeneralSettings.lengthAmount = checkLengthAmount;						
		end;
	end;		
	for k,v in pairs(moFillTypes) do			
		local emptyFruit = moSetGetAmount:getNoFoundSiloAmount(k);			
		if moSetGetGui.page[1].allFruits then
			if emptyFruit then					
				if moSetGetGui.page[1].allPrices then
					if tonumber(moFillTypes[k].bestPrice) > 0 and tonumber(moFillTypes[k].pricePerLiter) > 0 then setNextTable(k, true);end;
				else
					setNextTable(k, true);												
				end;
			else
				if moSetGetGui.page[1].allPrices then
					if tonumber(moFillTypes[k].bestPrice) > 0 and tonumber(moFillTypes[k].pricePerLiter) > 0 then setNextTable(k, false);end;
				else
					setNextTable(k, false);						
				end;
			end;
		else
			if emptyFruit then
				if moSetGetGui.page[1].allPrices then
					if tonumber(moFillTypes[k].bestPrice) > 0 and tonumber(moFillTypes[k].pricePerLiter) > 0 then setNextTable(k, true);end;						
				else					
					setNextTable(k, true);
				end;					
			end;
		end;	
	end;
	return tablePos, fillTypesStationsSort;
end;